package com.brilliance.isc.funds.fttfcm.register.doc;

import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.register.document.IDocumentRegister;
import com.brilliance.isc.common.register.document.common.SetmodDocumentRegister;
import com.brilliance.isc.common.trndoc.service.TrndocService;
import com.brilliance.isc.common.trndoc.vo.TrndocVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.funds.fttfcm.service.FttfcmTransactionServiceImpl;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Systems;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

import static com.brilliance.mda.runtime.mda.Constants.NO_ERROR;

/**
 * @program: isc-funds
 * @ClassName: FttfcmDocumentRegister
 * @description: 结售汇平盘确认 Fttfcm 报文注册
 * @author: Lenovo
 * @create: 2024-10-11 17:47
 */
@Component("fttfcm.documentRegister")
public class FttfcmDocumentRegister implements IDocumentRegister {

    @Autowired
    TrndocService trndocService;
    @Resource
    PtsptaToolComponent ptsptaToolComponent;
    @Autowired
    private SetmodDocumentRegister setmodDocumentRegister;

    @Resource
    FtToolComponent ftToolComponent;

    @Override
    public void registerDocument(TrndocVo trndoc) {

        doRegister(trndoc);
        setmodDocumentRegister.registerDocument(trndoc);
        //entmodDocumentRegister.registerDocument(trndoc);
        
    }

    public void doRegister(TrndocVo trndoc){
        FtdBizInfoVo rec = (FtdBizInfoVo) trndoc.getRec();
        PtsptaVo troPtspta = ptsptaToolComponent.getPtsFromListByRol(trndoc.getPtsptas(), "TRO");
        PtsptaVo triPtspta = ptsptaToolComponent.getPtsFromListByRol(trndoc.getPtsptas(), "TRI");


        
        if( 1==1 )
        {
            if( ptsptaToolComponent.ptsIsRolSet(troPtspta ))
            {
                switch( rec.getMsgtyp() )
                {
                    case "320":
                        trndocService.defDocEot (trndoc,  "TRN", "320", "\\FTT320L1", "LET", 0, troPtspta.getPts().getPtainr(), "\\FTDGRP\\REC","MT 320", "TRO", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN320", "SWT", "MT320");
                        break;
                    case "199":
                        trndocService.defDocEot ( trndoc, "TRN", "199", "\\FTT199L1", "LET", 0, troPtspta.getPts().getPtainr(), "\\FTDGRP\\REC", "MT 199", "TRO", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN199", "SWT", "MT199");
                        break;
                    case "299":
                        trndocService.defDocEot (trndoc,  "TRN", "299", "\\FTT299L1", "LET", 0, troPtspta.getPts().getPtainr(), "\\FTDGRP\\REC", "MT 299", "TRO", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN299", "SWT", "MT299");
                        break;
                }
            }
            if( ptsptaToolComponent.ptsIsRolSet(triPtspta) )
            {
                switch(  rec.getMsgtyp() )
                {
                    case "320":
                        trndocService.defDocEot (trndoc,  "TRN", "320", "\\FTT320L1", "LET", 0, triPtspta.getPts().getPtainr(), "\\FTDGRP\\REC","MT 320", "TRI", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN320", "SWT", "MT320");
                        break;
                    case "199":
                        trndocService.defDocEot (trndoc,  "TRN", "199", "\\FTT199L1", "LET", 0, triPtspta.getPts().getPtainr(), "\\FTDGRP\\REC", "MT 199", "TRI", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN199", "SWT", "MT199");
                        break;
                    case "299":
                        trndocService.defDocEot (trndoc,  "TRN", "299", "\\FTT299L1", "LET", 0, triPtspta.getPts().getPtainr(), "\\FTDGRP\\REC", "MT 299", "TRI", "" );
                        trndocService.setDocSendFormat(trndoc, "TRN299", "SWT", "MT299");
                        break;
                }
            }
        }
    }
}
