package com.brilliance.isc.funds.fttfcn.register.dissav;

import com.brilliance.isc.common.register.diasav.IDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.DftcreDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.LiaallDiasavRegister;
import com.brilliance.isc.common.register.diasav.common.LiaallDiasavZZZRegister;
import com.brilliance.isc.common.register.diasav.common.TrtcreDiasavRegister;
import com.brilliance.isc.common.trndia.service.TrndiaService;
import com.brilliance.isc.common.trndia.vo.TrndiaVo;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import com.brilliance.mda.runtime.mda.util.Strings;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;

import static com.brilliance.mda.runtime.mda.Constants.DiaToReplace;
import static com.brilliance.mda.runtime.mda.Constants.NULLDATE;

/**
 * @program: isc-funds
 * @ClassName: FttfcnDiasavRegister
 * @description: 结售汇平盘确认 fttfcn 备忘录注册
 * @author: Lenovo
 * @create: 2024-10-11 17:30
 */
@Component("fttfcn.diasavRegister")
public class FttfcnDiasavRegister implements IDiasavRegister {

    @Autowired
    private TrndiaService trndiaService;
    @Autowired
    private LiaallDiasavRegister liaallDiasavRegister;
    @Autowired
    private LiaallDiasavZZZRegister liaallDiasavZZZRegister;
    @Autowired
    private TrtcreDiasavRegister trtcreDiasavRegister;
    @Autowired
    private DftcreDiasavRegister dftcreDiasavRegister;

    @Override
    public void diasav(TrndiaVo trndia) {
        trnDiasav(trndia);
        liaallDiasavRegister.diasav(trndia);
        liaallDiasavZZZRegister.diasav(trndia);
        trtcreDiasavRegister.diasav(trndia);
        dftcreDiasavRegister.diasav(trndia);
    }

    private void trnDiasav(TrndiaVo trndiaVo) {

    }
}