package com.brilliance.isc.funds.fttfcn.register.settle;

import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NO_ERROR;
import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fttfcn.settleRegister")
public class FttfcnSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;


    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private FtToolComponent ftToolComponent;

    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FtdBizInfoVo rec = (FtdBizInfoVo) setmodVo.getRec();

        Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(rec.getObjinr());

        setmodVo.setDoccur(ftdgrp.getCbs().getMax().getCur());
        setmodVo.setDocamt(rec.getCanamt());
        SetglgVo setglg = setmodVo.getSetglg();




        setglgService.setglgClrAmount ( setglg,"TRN" );
        String cact = glemodService.getAvailAcc ( "FT-FXR", setmodVo.getDoccur(), "", ftdgrp.getCbs().getMax().getAmt() );
        String cdtKey = setglgService.setglgAddAmount ( setglg,"TRN", "OWN", setmodVo.getDoccur(), rec.getCanamt().negate(), "", "FTC", "C", cact, "" );
        String dbtKey = NULLSTR;
        if( MdaUtils.compareTo(ftdgrp.getRec().getFttyp(),"LI") == 0 || MdaUtils.compareTo(ftdgrp.getRec().getFttyp(),"DI") == 0 )
        {
            dbtKey =setglgService.setglgAddAmount ( setglg,"TRN", "TRO", setmodVo.getDoccur(), rec.getCanamt(), "", "DBD", "C", "", "" );
        }
        else
        {
            dbtKey = setglgService.setglgAddAmount ( setglg,"TRN", "TRI", setmodVo.getDoccur(), rec.getCanamt(), "", "DBD", "C", "", "" );
        }


    }



}
