package com.brilliance.isc.funds.fttpcn.service;

import com.brilliance.isc.bo.Ftd;
import com.brilliance.isc.bo.Pty;import com.brilliance.isc.bo.Smh;import com.brilliance.isc.bo.model.Ftacbs;
import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.bo.model.Fttp;
import com.brilliance.isc.common.cbsmod.service.CbsmodService;
import com.brilliance.isc.common.component.PtsptaToolComponent;
import com.brilliance.isc.common.component.SptDataComponent;
import com.brilliance.isc.common.contants.CommonContants;import com.brilliance.isc.common.context.SettleContext;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.common.transaction.AbstractTransactionService;
import com.brilliance.isc.common.transaction.help.TransactionHelpService;
import com.brilliance.isc.common.transaction.help.TransactionServiceSet;
import com.brilliance.isc.common.trnmod.service.TrnmodService;
import com.brilliance.isc.common.trnmod.vo.TrnmodVo;
import com.brilliance.isc.common.vo.BizAmdInfoVo;import com.brilliance.isc.common.vo.BizInfoVo;
import com.brilliance.isc.funds.bo.funds.FttpcmStoreBo;import com.brilliance.isc.funds.bo.funds.FttpcnStoreBo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.funds.fttpcn.check.FttpcnValidator;
import com.brilliance.isc.mda.dao.PtyMapper;import com.brilliance.isc.mda.dao.SmhMapper;import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Dates;
import com.brilliance.mda.runtime.mda.util.Decimals;import com.brilliance.mda.runtime.mda.util.MdaUtils;import com.brilliance.mda.runtime.mda.util.Strings;import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import javax.annotation.PostConstruct;import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.Map;import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;import static com.brilliance.mda.runtime.mda.Constants.PanStaShow;


@Service("fttpcn.transaction")
public class FttpcnTransactionServiceImpl extends AbstractTransactionService<FttpcnStoreBo>{

    @Resource
    private FttpcnValidator fttpcnValidator;
    @Resource
    private FtToolComponent ftToolComponent;
    @Resource
    private TrnmodService trnmodService;
    @Resource
    private TransactionHelpService transactionHelpService;
    @Resource
    private CbsmodService cbsmodService;
    @Resource
    private SettleContext settleContext;
    @Resource
    private SysmodService sysmodService;
    @Autowired
    SptDataComponent sptDataComponent;
    @Autowired
    PtsptaToolComponent ptsptaToolComponent;
    @Resource
    private SmhMapper smhMapper;
    @Resource
    private PtyMapper ptyMapper;

    @PostConstruct
    public void regisertService() {
         serviceRegisterMaps.put(CommonContants.SETMOD_SERVICE, "Y");
         serviceRegisterMaps.put(CommonContants.TRNDOC_SERVICE, "Y");
         serviceRegisterMaps.put(CommonContants.GLEMOD_SERVICE, "Y");
         serviceRegisterMaps.put(CommonContants.TRNDIA_SERVICE, "Y");
         serviceRegisterMaps.put(CommonContants.TRNMOD_SERVICE, "Y");
    }
    @Override
    protected void txnSave(FttpcnStoreBo transactionVo) {
            ruleMtabutSavN500(transactionVo);
    }
    public void ruleMtabutSavN500(FttpcnStoreBo fttpcnStoreBo){
        TrnmodVo trnmodVo = transactionHelpService.getTransactionStoreSet().getTrnmodVo();
        ftToolComponent.getref(fttpcnStoreBo.getFtdgrp());
        ftToolComponent.sav(fttpcnStoreBo.getFtdgrp());
        trnmodService.trnSetFromContract(trnmodVo);
        cbsSav(fttpcnStoreBo, trnmodVo);

    }
    @Override
    protected Map<String, String> txnCheck(FttpcnStoreBo transactionVo) {
        return fttpcnValidator.validate(transactionVo);
    }

    @Override
    protected BizInfoVo buildBizInfo(FttpcnStoreBo transactionVo) {
        FtdBizInfoVo bizInfoVo = new FtdBizInfoVo();
                   bizInfoVo.setObjtyp("FTD");
                   Ftd rec = transactionVo.getFtdgrp().getRec();
                   bizInfoVo.setObjinr(rec.getInr());
                   bizInfoVo.setOwnref(rec.getOwnref());
                   bizInfoVo.setFttyp(rec.getFttyp());
                   bizInfoVo.setRat(rec.getRat());
                   bizInfoVo.setBranchInr(rec.getBranchinr());
                   bizInfoVo.setEtyextkey(rec.getEtyextkey());
                   bizInfoVo.setBranchInr(rec.getBranchinr());
                   bizInfoVo.setValdat(rec.getValdat());
                   return bizInfoVo;
    }

     @Override
     protected void updateBizInfoVo(BizInfoVo bizInfoVo, FttpcnStoreBo transactionVo) {
            bizInfoVo.setObjinr(transactionVo.getFtdgrp().getRec().getInr());
        }
      @Override
     protected BizAmdInfoVo buildBizAmdInfo(FttpcnStoreBo transactionVo) {
            return null;
        }
    @Override
    public void beforeSave(FttpcnStoreBo transactionVo) {
         transactionVo.reset();
         Ftdgrp ftdgrp = transactionVo.getFtdgrp();

         TransactionServiceSet transactionServiceSet = transactionHelpService.getTransactionStoreSet();
         transactionServiceSet.setRec(ftdgrp.getRec());
         transactionServiceSet.setBlk(ftdgrp.getBlk());
         transactionServiceSet.setTransactionVo(transactionVo);

         ftToolComponent.collectCbsMap(transactionServiceSet, "", ftdgrp.getCbs(), "max");
         ftToolComponent.collectPtsList(transactionServiceSet, ftdgrp, null);
         settleContext.loadSettleSession(transactionVo.getTransName(), transactionVo.getUserId(), buildBizInfo(transactionVo), transactionServiceSet.getPtsList());
    }
    public void cbsSav(FttpcnStoreBo transactionVo, TrnmodVo trnmodVo){
        String trninr = transactionHelpService.getTrninr();
        cbsmodService.cbsTrnSetNew("TRN",trninr);
        Ftacbs cbs = transactionVo.getFtdgrp().getCbs();
        trnmodService.cbsTrnStore("OPNAMT","AMT1",Dates.today(),cbs.getOpn2().getCur(),
                                        transactionVo.getCanamt().negate(),"Position Transfer",transactionVo.getFtdgrp().getRec(), trninr);

        cbsmodService.cbsTrnCommit();
    }

    @Override
    public FttpcnStoreBo init(FttpcnStoreBo fttpcnStoreBo){
        fttpcnStoreBo.reset();
        String fttinr = fttpcnStoreBo.getFtdgrp().getRec().getInr();
        if (sptDataComponent.needMergeSptData(fttpcnStoreBo)){
            fttinr = fttpcnStoreBo.getSpt().getObjinr();
        }
        Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(fttinr);
        fttpcnStoreBo.setFtdgrp(ftdgrp);
        init950(fttpcnStoreBo);
        init1000(fttpcnStoreBo);
        return fttpcnStoreBo;
    }

    private void init950(FttpcnStoreBo fttpcmStoreBo){
        Ftdgrp ftdgrp = fttpcmStoreBo.getFtdgrp();
        if(!fttpcmStoreBo.isModified("canamt")){
            fttpcmStoreBo.setCanamt(ftdgrp.getCbs().getMax().getAmt());
        }
        if (!fttpcmStoreBo.isModified("cancur")){
            fttpcmStoreBo.setCancur(ftdgrp.getCbs().getMax().getCur());
        }
    }

    private void init1000(FttpcnStoreBo fttpcnStoreBo){
        Fttp fttp = fttpcnStoreBo.getFttp();
        String extkey = SettleContext.getUserSession().getUsr().getExtkey();
        fttpcnStoreBo.getFtdgrp().getRec().setOwnusr(extkey);
        fttp.setPansta(PanStaShow);


    }

}
