package com.brilliance.isc.funds.fxtsel.resource;

import com.brilliance.isc.funds.fxtsel.service.FxtselService;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.funds.FxtselQueryVo;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/fxtsel")
public class FxtselResource {
    @Autowired
    private FxtselService fxtselService;


    /*
     *
     * */
    @PostMapping("/list")
    public ResponseSet list(@RequestBody FxtselQueryVo fxtselQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.list(fxtselQueryVo));
    }

    @PostMapping("/listjsh")
    public ResponseSet listjsh(@RequestBody FxtselQueryVo fxtselQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.listjsh(fxtselQueryVo));
    }

    @PostMapping("/listjshpp")
    public ResponseSet listjshpp(@RequestBody FxtselQueryVo fxtselQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.listjshpp(fxtselQueryVo));
    }

    @PostMapping("/listdhpp")
    public ResponseSet listdhpp(@RequestBody FxtselQueryVo fxtselQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.listdhpp(fxtselQueryVo));
    }

    /**
     * 处理按钮查看能够进行的交易
     */
    @ApiOperation("处理按钮查看能够进行的交易")
    @PostMapping("/dealWithByOwnref")
    public ResponseSet dealWithByOwnref(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.dealWithByInr(trnCodeQueryVo));
    }

    @ApiOperation("处理按钮查看能够进行的交易")
    @PostMapping("/dealWithByInr")
    public ResponseSet dealWithByInr(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(fxtselService.dealWithByInr(trnCodeQueryVo));
    }


    /**
     * 详情页面初始化
     */
    @PostMapping("/selectXxdByPrimaryKey")
    public ResponseSet selectXxdByPrimaryKey(@RequestBody Map<String, String> map) {
        return ResponseSet.simpleSuccess(fxtselService.selectXxdByPrimaryKey(map));
    }
}













