package com.brilliance.isc.funds.bo.funds;

import com.brilliance.isc.bo.Act;
import com.brilliance.isc.bo.Smh;
import com.brilliance.isc.bo.Spt;
import com.brilliance.isc.bo.model.*;
import com.brilliance.isc.common.nosmod.bo.Nosmod;
import com.brilliance.isc.common.transaction.vo.BaseTransactionVo;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: CrtcriStoreBo
 * @description: 汇入清算 bo
 * @author: huangshunlin
 * @create: 2024-10-16 20:24
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class CrtcriStoreBo extends BaseTransactionVo {

    //Status I-INCOMING, O-OUTGOING, N-NOTNEED (max=1)
    private String clrsta = NULLSTR;
    //Object Type of Associated Contract Optional (max=6)
    private String rcvobjtyp = NULLSTR;

    private Crdgrp crdgrp;

    private Crtp crtp;

    private Smh smh;

    private Smh corsmh;

    private Act sndact;

    private Act aplact;

    private Act rcvact;

    private Spt crtspt;


    private Bodgrp bodgrp;

    private Ccdgrp ccdgrp;

    private Bedgrp bedgrp;

    private Ledgrp ledgrp;


    private Btdgrp btdgrp;


    private Ltdgrp ltdgrp;


    private Gidgrp gidgrp;


//    private Cldgrp cldgrp;

    private Cpdgrp cpdgrp;

    private Nosmod nosmod;

    @Override
    public void reset() {
        super.reset();
        if (crdgrp == null) {
            crdgrp = new Crdgrp();
        }
        crdgrp.reset();
        if (crtp == null) {
            crtp = new Crtp();
        }
        crtp.reset();

        if (smh == null) {
            smh = new Smh();
        }
        if (corsmh == null) {
            corsmh = new Smh();
        }
        if (sndact == null) {
            sndact = new Act();
        }

        if (aplact == null) {
            aplact = new Act();
        }

        if (rcvact == null) {
            rcvact = new Act();
        }

        if (crtspt == null) {
            crtspt = new Spt();
        }
        if (bodgrp == null) {
            bodgrp = new Bodgrp();
        }
        bodgrp.reset();

        if (ccdgrp == null) {
            ccdgrp = new Ccdgrp();
        }
        ccdgrp.reset();

        if (bedgrp == null) {
            bedgrp = new Bedgrp();
        }
        bedgrp.reset();

        if (ledgrp == null) {
            ledgrp = new Ledgrp();
        }
        ledgrp.reset();
        if (btdgrp == null) {
            btdgrp = new Btdgrp();
        }
        btdgrp.reset();
        if (ltdgrp == null) {
            ltdgrp = new Ltdgrp();
        }
        ltdgrp.reset();

        if (gidgrp == null) {
            gidgrp = new Gidgrp();
        }
        gidgrp.reset();
        if (cpdgrp == null) {
            cpdgrp = new Cpdgrp();
        }
        cpdgrp.reset();
        if (nosmod == null) {
            nosmod = new Nosmod();
        }
        nosmod.reset();
    }
}
