package com.brilliance.isc.funds.vo.funds;

import com.brilliance.isc.bo.Smh;
import com.brilliance.isc.bo.SptVo;
import com.brilliance.isc.common.nosmod.vo.NosmodVo;
import com.brilliance.isc.common.transaction.vo.BaseTransactionVo;
import com.brilliance.isc.common.vo.ActVo;
import com.brilliance.isc.vo.funds.CrdgrpVo;
import com.brilliance.isc.vo.funds.CrtpVo;
import com.brilliance.isc.vo.model.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: CrtcriStoreVo
 * @description: 汇入清算 bo
 * @author: huangshunlin
 * @create: 2024-10-16 20:26
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class CrtcriStoreVo extends BaseTransactionVo {

    //Status I-INCOMING, O-OUTGOING, N-NOTNEED (max=1)
    private String clrsta = NULLSTR;
    //Object Type of Associated Contract Optional (max=6)
    private String rcvobjtyp = NULLSTR;

    private CrdgrpVo crdgrp;

    private CrtpVo crtp;

    private Smh smh;

    private Smh corsmh;

    private ActVo sndact;

    private ActVo aplact;

    private ActVo rcvact;

    private SptVo crtspt;

    private Bodgrp bodgrp;

    private Ccdgrp ccdgrp;

    private Bedgrp bedgrp;

    private Ledgrp ledgrp;


    private Btdgrp btdgrp;


    private Ltdgrp ltdgrp;


    private Gidgrp gidgrp;


//    private Cldgrp cldgrp;

    private CpdgrpVo cpdgrp;

    private NosmodVo nosmod;

    @Override
    public void reset() {
        super.reset();
        if (crdgrp == null) {
            crdgrp = new CrdgrpVo();
        }
        crdgrp.reset();
        if (crtp == null) {
            crtp = new CrtpVo();
        }
        crtp.reset();

        if (smh == null) {
            smh = new Smh();
        }
        if (corsmh == null) {
            corsmh = new Smh();
        }
        if (sndact == null) {
            sndact = new ActVo();
        }

        if (aplact == null) {
            aplact = new ActVo();
        }

        if (rcvact == null) {
            rcvact = new ActVo();
        }

        if (crtspt == null) {
            crtspt = new SptVo();
        }

        if (bodgrp == null) {
            bodgrp = new Bodgrp();
        }
        bodgrp.reset();

        if (ccdgrp == null) {
            ccdgrp = new Ccdgrp();
        }
        ccdgrp.reset();

        if (bedgrp == null) {
            bedgrp = new Bedgrp();
        }
        bedgrp.reset();

        if (ledgrp == null) {
            ledgrp = new Ledgrp();
        }
        ledgrp.reset();
        if (btdgrp == null) {
            btdgrp = new Btdgrp();
        }
        btdgrp.reset();
        if (ltdgrp == null) {
            ltdgrp = new Ltdgrp();
        }
        ltdgrp.reset();

        if (gidgrp == null) {
            gidgrp = new Gidgrp();
        }
        gidgrp.reset();
        if (cpdgrp == null) {
            cpdgrp = new CpdgrpVo();
        }
        cpdgrp.reset();
        //    private Cldgrp cldgrp;
        if (nosmod == null) {
            nosmod = new NosmodVo();
        }
        nosmod.reset();
    }
}
